package com.zhongzheng.modules.inform.service.impl;

import cn.hutool.core.bean.BeanUtil;
import cn.hutool.core.util.StrUtil;
import com.baomidou.mybatisplus.core.toolkit.CollectionUtils;
import com.zhongzheng.common.utils.DateUtils;
import org.springframework.stereotype.Service;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.github.pagehelper.Page;
import com.zhongzheng.modules.inform.bo.InformExamAddBo;
import com.zhongzheng.modules.inform.bo.InformExamQueryBo;
import com.zhongzheng.modules.inform.bo.InformExamEditBo;
import com.zhongzheng.modules.inform.domain.InformExam;
import com.zhongzheng.modules.inform.mapper.InformExamMapper;
import com.zhongzheng.modules.inform.vo.InformExamVo;
import com.zhongzheng.modules.inform.service.IInformExamService;

import java.util.Collection;
import java.util.Collections;
import java.util.List;
import java.util.stream.Collectors;

/**
 * 【请填写功能名称】Service业务层处理
 *
 * @author ruoyi
 * @date 2021-11-23
 */
@Service
public class InformExamServiceImpl extends ServiceImpl<InformExamMapper, InformExam> implements IInformExamService {

    @Override
    public InformExamVo queryById(Long id){
        InformExam db = this.baseMapper.selectById(id);
        return BeanUtil.toBean(db, InformExamVo.class);
    }

    @Override
    public List<InformExamVo> queryList(InformExamQueryBo bo) {
        LambdaQueryWrapper<InformExam> lqw = Wrappers.lambdaQuery();
        lqw.eq(bo.getInformId() != null, InformExam::getInformId, bo.getInformId());
        lqw.eq(bo.getCourseId() != null, InformExam::getCourseId, bo.getCourseId());
        lqw.eq(bo.getExamId() != null, InformExam::getExamId, bo.getExamId());
        lqw.eq(bo.getModuleId() != null, InformExam::getModuleId, bo.getModuleId());
        lqw.eq(bo.getChapterId() != null, InformExam::getChapterId, bo.getChapterId());
        return entity2Vo(this.list(lqw));
    }

    /**
    * 实体类转化成视图对象
    *
    * @param collection 实体类集合
    * @return
    */
    private List<InformExamVo> entity2Vo(Collection<InformExam> collection) {
        List<InformExamVo> voList = collection.stream()
                .map(any -> BeanUtil.toBean(any, InformExamVo.class))
                .collect(Collectors.toList());
        if (collection instanceof Page) {
            Page<InformExam> page = (Page<InformExam>)collection;
            Page<InformExamVo> pageVo = new Page<>();
            BeanUtil.copyProperties(page,pageVo);
            pageVo.addAll(voList);
            voList = pageVo;
        }
        return voList;
    }

    @Override
    public Boolean insertByAddBo(InformExamAddBo bo) {
        InformExam add = BeanUtil.toBean(bo, InformExam.class);
        validEntityBeforeSave(add);
        add.setCreateTime(DateUtils.getNowTime());
        add.setUpdateTime(DateUtils.getNowTime());
        return this.save(add);
    }

    @Override
    public Boolean updateByEditBo(InformExamEditBo bo) {
        InformExam update = BeanUtil.toBean(bo, InformExam.class);
        validEntityBeforeSave(update);
        update.setUpdateTime(DateUtils.getNowTime());
        return this.updateById(update);
    }

    /**
     * 保存前的数据校验
     *
     * @param entity 实体类数据
     */
    private void validEntityBeforeSave(InformExam entity){
        //TODO 做一些数据校验,如唯一约束
    }

    @Override
    public Boolean deleteWithValidByIds(Collection<Long> ids, Boolean isValid) {
        if(isValid){
            //TODO 做一些业务上的校验,判断是否需要校验
        }
        return this.removeByIds(ids);
    }

    @Override
    public List<InformExamVo> queryExam(Long informId) {
        List<InformExamVo> informExamVo = baseMapper.queryExam(informId);
        return informExamVo;
    }
}
